//+------------------------------------------------------------------+
//|                                         Copyright 2015, SergDeev |
//|                                                http://fx-prog.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, SergDeev"
#property description ""
#property link      "http://fx-prog.ru"
#property version   "1.1"
#property strict

enum ord_type {
   BUY,
   SELL
};

extern string Pair1                 = "EURUSD";
extern string Pair2                 = "GBPUSD";
extern double Lot1                  = 0.01;
extern double Lot2                  = 0.01;
extern ord_type Direct1             = BUY;
extern ord_type Direct2             = SELL;
extern bool useRevers               = true;
extern double CloseOrder            = 50;
extern double Spread                = 20;
extern double SaveCapital           = 100;
extern double CloseLock             = 150;
extern int MAGIC                    = 20160921;

int num_repeat=5;

datetime startTime = 0;

int OnInit() {
 if (MarketInfo(Pair1,MODE_POINT) == 0 || MarketInfo(Pair2,MODE_POINT) == 0) {
  Alert("Error Symbols !!!");
  return(INIT_FAILED);
 }
 string vx = Pair1+"_"+Pair2+"_"+IntegerToString(MAGIC);
 double st;
 if (!GlobalVariableCheck(vx)) {
  startTime = TimeCurrent();
  st = (double)startTime;
  GlobalVariableSet(vx,st);
 }
 else {
  if (CalculateCurrentOrders(Pair1,"main",-1)==0 && CalculateCurrentOrders(Pair2,"main",-1)==0) {
   startTime = TimeCurrent();
   st = (double)startTime;
   GlobalVariableSet(vx,st);
  }
  else {
   st = GlobalVariableGet(vx);
   startTime = (datetime)st;
  }
 }

 return(INIT_SUCCEEDED);
}
double NormalizeLots(string symbol, double v) {
 
 double maxLot = MarketInfo(symbol,MODE_MAXLOT);
 double minLot = MarketInfo(symbol,MODE_MINLOT);
 double lotStep = MarketInfo(symbol,MODE_LOTSTEP);
 double x = NormalizeDouble((v/lotStep),0) * lotStep;
 if (x < minLot) x = minLot;
 if (x > maxLot) x = maxLot;
 return(x);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason) {
}

void CheckForOpen() {
int num,id;
 if (!useRevers || LastOrder(Pair1)==-1) {
  num=0; id=-1;
  if (Direct1 == BUY) {
   while (num < num_repeat && id==-1) {
    id = OrderSend(Pair1,OP_BUY,NormalizeLots(Pair1,Lot1),MarketInfo(Pair1,MODE_ASK),(int)MarketInfo(Pair1,MODE_SPREAD),0,0,"main",MAGIC,0,clrBlue);
    if (id==-1) {
     Print("Error Open BUY ",Pair1," ",_LastError);
     Sleep(1000);
     num_repeat++;
    }
   }
  }
  else {
   while (num < num_repeat && id==-1) {
    id = OrderSend(Pair1,OP_SELL,NormalizeLots(Pair1,Lot1),MarketInfo(Pair1,MODE_BID),(int)MarketInfo(Pair1,MODE_SPREAD),0,0,"main",MAGIC,0,clrRed);
    if (id==-1) {
     Print("Error Open SELL ",Pair1," ",_LastError);
     Sleep(1000);
     num_repeat++;
    }
   }
  }
  if (id != -1) {
   num=0; id=-1;
   if (Direct2 == BUY) {
    while (num < num_repeat && id==-1) {
     id = OrderSend(Pair2,OP_BUY,NormalizeLots(Pair2,Lot2),MarketInfo(Pair2,MODE_ASK),(int)MarketInfo(Pair2,MODE_SPREAD),0,0,"main",MAGIC,0,clrBlue);
     if (id==-1) {
      Print("Error Open BUY ",Pair2," ",_LastError);
      Sleep(1000);
      num_repeat++;
     }
    }
   }
   else {
    while (num < num_repeat && id==-1) {
     id = OrderSend(Pair2,OP_SELL,NormalizeLots(Pair2,Lot2),MarketInfo(Pair2,MODE_BID),(int)MarketInfo(Pair2,MODE_SPREAD),0,0,"main",MAGIC,0,clrRed);
     if (id==-1) {
      Print("Error Open SELL ",Pair2," ",_LastError);
      Sleep(1000);
      num_repeat++;
     }
    }
   }
  }
 }
 else {
  num=0; id=-1;
  if (LastOrder(Pair1)==OP_SELL) {
   while (num < num_repeat && id==-1) {
    id = OrderSend(Pair1,OP_BUY,NormalizeLots(Pair1,Lot1),MarketInfo(Pair1,MODE_ASK),(int)MarketInfo(Pair1,MODE_SPREAD),0,0,"main",MAGIC,0,clrBlue);
    if (id==-1) {
     Print("Error Open BUY ",Pair1," ",_LastError);
     Sleep(1000);
     num_repeat++;
    }
   }
  }
  else if (LastOrder(Pair1)==OP_BUY) {
   while (num < num_repeat && id==-1) {
    id = OrderSend(Pair1,OP_SELL,NormalizeLots(Pair1,Lot1),MarketInfo(Pair1,MODE_BID),(int)MarketInfo(Pair1,MODE_SPREAD),0,0,"main",MAGIC,0,clrRed);
    if (id==-1) {
     Print("Error Open SELL ",Pair1," ",_LastError);
     Sleep(1000);
     num_repeat++;
    }
   }
  }
  num=0; id=-1;
  if (LastOrder(Pair2)==OP_SELL) {
   while (num < num_repeat && id==-1) {
    id = OrderSend(Pair2,OP_BUY,NormalizeLots(Pair2,Lot2),MarketInfo(Pair2,MODE_ASK),(int)MarketInfo(Pair2,MODE_SPREAD),0,0,"main",MAGIC,0,clrBlue);
    if (id==-1) {
     Print("Error Open BUY ",Pair2," ",_LastError);
     Sleep(1000);
     num_repeat++;
    }
   }
  }
  else if (LastOrder(Pair2)==OP_BUY) {
   while (num < num_repeat && id==-1) {
    id = OrderSend(Pair2,OP_SELL,NormalizeLots(Pair2,Lot2),MarketInfo(Pair2,MODE_BID),(int)MarketInfo(Pair2,MODE_SPREAD),0,0,"main",MAGIC,0,clrRed);
    if (id==-1) {
     Print("Error Open SELL ",Pair2," ",_LastError);
     Sleep(1000);
     num_repeat++;
    }
   }
  }
 }
}

//+------------------------------------------------------------------+
void CheckForClose() {
int num=0,id=-1;
 if (CalculateCurrentOrders(Pair1,"lock",-1)==0 && CalculateCurrentOrders(Pair2,"lock",-1)==0) {
  double profit = CalculateProfitOrders(Pair1,"main",-1)+CalculateProfitOrders(Pair2,"main",-1);
  if (profit >= CloseOrder) {
   if (CloseProfitOrders(Pair1,"",-1)) CloseProfitOrders(Pair2,"",-1);
  }
  else if (SaveCapital != 0 && profit <= -1*SaveCapital) {
   num=0; id=-1;
   if (CalculateCurrentOrders(Pair1,"main",OP_BUY)>0) {
    while (num < num_repeat && id==-1) {
     id = OrderSend(Pair1,OP_SELL,NormalizeLots(Pair1,Lot1),MarketInfo(Pair1,MODE_BID),(int)MarketInfo(Pair1,MODE_SPREAD),0,0,"lock",MAGIC,0,clrRed);
     if (id==-1) {
      Print("Error Open SELL ",Pair1," ",_LastError);
      Sleep(1000);
      num_repeat++;
     }
    }
   }
   else if (CalculateCurrentOrders(Pair1,"main",OP_SELL)>0) {
    while (num < num_repeat && id==-1) {
     id = OrderSend(Pair1,OP_BUY,NormalizeLots(Pair1,Lot1),MarketInfo(Pair1,MODE_ASK),(int)MarketInfo(Pair1,MODE_SPREAD),0,0,"lock",MAGIC,0,clrBlue);
     if (id==-1) {
      Print("Error Open BUY ",Pair1," ",_LastError);
      Sleep(1000);
      num_repeat++;
     }
    }
   }
  }
  if (id != -1) {
   num=0; id=-1;
   if (CalculateCurrentOrders(Pair2,"main",OP_BUY)>0) {
    while (num < num_repeat && id==-1) {
     id = OrderSend(Pair2,OP_SELL,NormalizeLots(Pair2,Lot2),MarketInfo(Pair2,MODE_BID),(int)MarketInfo(Pair2,MODE_SPREAD),0,0,"lock",MAGIC,0,clrRed);
     if (id==-1) {
      Print("Error Open SELL ",Pair2," ",_LastError);
      Sleep(1000);
      num_repeat++;
     }
    }
   }
   else if (CalculateCurrentOrders(Pair2,"main",OP_SELL)>0) {
    while (num < num_repeat && id==-1) {
     id = OrderSend(Pair2,OP_BUY,NormalizeLots(Pair2,Lot2),MarketInfo(Pair2,MODE_ASK),(int)MarketInfo(Pair2,MODE_SPREAD),0,0,"lock",MAGIC,0,clrBlue);
     if (id==-1) {
      Print("Error Open BUY ",Pair2," ",_LastError);
      Sleep(1000);
      num_repeat++;
     }
    }
   }
  }
 }
 else {
  double profit = CalculateProfitOrders(Pair1,"main",-1)+CalculateProfitOrders(Pair2,"main",-1);
  if (CloseLock != 0 && profit >= CloseLock) {
   if (CloseProfitOrders(Pair1,"lock",-1)) CloseProfitOrders(Pair2,"lock",-1);
  }
 }
}

bool CloseProfitOrders(string symbol, string comment, int mode) {
   bool res=false;
   for(int i=0;i<OrdersTotal();i++) {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if (OrderMagicNumber() == MAGIC)
      if (OrderSymbol() == symbol)
      if (OrderComment() == comment || comment == "")
      if (OrderType()==mode || mode==-1) {
       int num = 0; res = false;
       while (res == false && num < num_repeat) {
        if (OrderType() == OP_BUY) {
         res = OrderClose(OrderTicket(),OrderLots(),MarketInfo(symbol,MODE_BID),(int)MarketInfo(symbol,MODE_SPREAD),clrBlue);
         if (!res) {
          Print("Error Close BUY ",symbol," ",_LastError);
          Sleep(1000);
          num++;
         }
        }
        else if (OrderType() == OP_SELL) {
         res = OrderClose(OrderTicket(),OrderLots(),MarketInfo(symbol,MODE_ASK),(int)MarketInfo(symbol,MODE_SPREAD),clrRed);
         if (!res) {
          Print("Error Close SELL ",symbol," ",_LastError);
          Sleep(1000);
          num++;
         }
        }
       }
      }
     }
   return(res);
}

int LastOrder(string symbol) {
 int num = OrdersHistoryTotal();
 for (int i=num-1; i>=0; i--) {
   if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
   if (OrderSymbol() == symbol) 
   if (OrderMagicNumber() == MAGIC)
   if (OrderComment() == "main")
   if (OrderCloseTime() < startTime) return(-1);
   else return(OrderType());
 }
 return(-1);
}

double CalculateProfitOrders(string symbol, string comment, int mode) {
   double profit=0;
   for(int i=0;i<OrdersTotal();i++) {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if (OrderMagicNumber() == MAGIC)
      if (OrderSymbol() == symbol)
      if (OrderComment() == comment || comment == "")
      if (OrderType()==mode || mode==-1) profit += OrderProfit();
     }
   return(profit);
}

int CalculateCurrentOrders(string symbol, string comment, int mode) {
   int num=0;
   for(int i=0;i<OrdersTotal();i++) {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if (OrderMagicNumber() == MAGIC)
      if (OrderSymbol() == symbol)
      if (OrderComment() == comment || comment == "")
      if (OrderType()==mode || mode==-1) num++;
     }
   return(num);
}

void OnTick() {
   if(Bars<100 || IsTradeAllowed()==false) return;
   if (CalculateCurrentOrders(Pair1,"main",-1)==0 && CalculateCurrentOrders(Pair2,"main",-1)==0 && MarketInfo(Pair1,MODE_SPREAD)<Spread && MarketInfo(Pair2,MODE_SPREAD)<Spread) CheckForOpen();
   else if (CalculateCurrentOrders(Pair1,"main",-1)==1 && CalculateCurrentOrders(Pair2,"main",-1)==1) CheckForClose();
}
//+------------------------------------------------------------------+
